(* stack.ml: basic persistent
   stack based on built-in
   linked lists *)

let empty = [];;

let push stack x =
  x :: stack
;;

let pop stack =
  match stack with
  | [] -> failwith "empty stack"
  | top::rest -> rest
;;

let top stack =
  match stack with
  | [] -> failwith "empty stack"
  | top::rest -> top
;;
